#include "common.h"
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctype.h>

/* Turns out str?casecmp isn't required to be part of the standard C library. */
int strncasecmp_custom(const char *a, const char *b, int len)
 {
  for(; len > 0; --len, ++a, ++b)
   if(tolower(*b) != tolower(*a))
    return tolower(*b) - tolower(*a);
   else if(!*a)
    return 0;
   
  return 0;
 }

int strcasecmp_custom(const char *a, const char *b)
 {
  for(; ; ++a, ++b)
   if(tolower(*b) != tolower(*a))
    return tolower(*b) - tolower(*a);
   else if(!*a)
    return 0;
 }

const char *memoryString(unsigned int amount)
 {
  static const char *postfix_array[] = {"%0.0fB", "%0.1fKB", "%0.2fMB", "%0.3fGB"};
  static char value[32];
  const char **postfix = postfix_array;
  double a = amount;
  
  while(a >= 1024)
   {
    a /= 1024;
    ++postfix;
   }
   
  snprintf(value, sizeof value, *postfix, a);
  return value;
 }
 
const char *sourceString(const char *file, const char *function, unsigned int line)
 {
  static char value[128];
  if(function && *function)
   snprintf(value, sizeof value, "%s:%d:%s():", file&&*file?file:"<unknown>", line, function);
  else
   snprintf(value, 128, "%s:%d:", file&&*file?file:"<unknown>", line);
  
  return value;
 }

const char *dateString(void)
 {
  static char buffer[128];
  
  time_t date = time(0);
  strftime(buffer, sizeof buffer, "%b/%d/%Y %H:%M:%S", localtime(&date));
  
  return buffer;
 }
